/*----------------------------------------------------------------------
John Robbins
Microsoft Systems Journal, April 1998 - Bugslayer Column!
----------------------------------------------------------------------*/
#include "stdafx.h"
#include "CrashFinder.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE [] = __FILE__ ;
#endif

IMPLEMENT_DYNAMIC ( CMainFrame , CMDIFrameWnd )

BEGIN_MESSAGE_MAP ( CMainFrame , CMDIFrameWnd )
  //{{AFX_MSG_MAP(CMainFrame)
  ON_WM_CREATE ( )
  //}}AFX_MSG_MAP
END_MESSAGE_MAP ( )

static UINT indicators[ ] =
{
  ID_SEPARATOR      ,
  ID_INDICATOR_CAPS ,
  ID_INDICATOR_NUM  ,
  ID_INDICATOR_SCRL ,
} ;

CMainFrame :: CMainFrame ( )
            : CMDIFrameWnd ( )   ,
              m_wndStatusBar ( ) ,
              m_wndToolBar ( )
{
    ASSERT ( this ) ;
}

CMainFrame :: ~CMainFrame ( )
{
    ASSERT ( this ) ;
}

int CMainFrame :: OnCreate ( LPCREATESTRUCT lpCreateStruct )
{
    ASSERT ( this ) ;

    if ( -1 == CMDIFrameWnd::OnCreate ( lpCreateStruct ) )
    {
        return ( -1 ) ;
    }

    if ( ( !m_wndToolBar.Create ( this )               ) ||
         ( !m_wndToolBar.LoadToolBar ( IDR_MAINFRAME ) )    )
    {
        TRACE0 ( "Failed to create toolbar\n" ) ;
        return ( -1 ) ; // fail to create
    }

    if ( ( !m_wndStatusBar.Create ( this )                          ) ||
         ( !m_wndStatusBar.SetIndicators ( indicators ,
                                           sizeof ( indicators ) /
                                                 sizeof ( UINT ) )  )  )
    {
        TRACE0 ( "Failed to create status bar\n" ) ;
        return ( -1 ) ; // fail to create
    }

    // TODO: Remove this if you don't want tool tips or a resizeable toolbar
    m_wndToolBar.SetBarStyle ( m_wndToolBar.GetBarStyle ( ) |
                               CBRS_TOOLTIPS                |
                               CBRS_FLYBY                   |
                               CBRS_SIZE_DYNAMIC             ) ;

    return ( 0 ) ;
}

BOOL CMainFrame :: PreCreateWindow ( CREATESTRUCT & cs )
{
    ASSERT ( this ) ;

    // TODO: Modify the Window class or styles here by modifying
    //  the CREATESTRUCT cs

    return ( CMDIFrameWnd::PreCreateWindow ( cs ) ) ;
}

#ifdef _DEBUG
void CMainFrame :: AssertValid ( ) const
{
    ASSERT ( this ) ;

    CMDIFrameWnd::AssertValid ( ) ;
}

void CMainFrame :: Dump ( CDumpContext & dc ) const
{
    ASSERT ( this ) ;

    CMDIFrameWnd::Dump ( dc ) ;
}

#endif //_DEBUG


